Proxmox/setup/esphome-install.sh

125 lines
3.0 KiB
Bash
Raw Normal View History

2022-04-25 17:08:14 +02:00
#!/usr/bin/env bash
2022-04-17 22:12:14 +02:00
YW=`echo "\033[33m"`
2022-03-08 19:13:17 +01:00
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
2022-03-11 04:19:43 +01:00
RETRY_NUM=10
2022-03-08 19:13:17 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-17 22:12:14 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:08:14 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
local reason="Unknown failure occured."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-17 22:12:14 +02:00
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
2022-03-08 19:13:17 +01:00
2022-04-17 22:12:14 +02:00
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Setting up Container OS "
2022-03-08 19:13:17 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
1>&2 echo -en "${CROSS}${RD} No Network! "
sleep $RETRY_EVERY
((NUM--))
if [ $NUM -eq 0 ]
then
1>&2 echo -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
exit 1
fi
done
2022-04-17 22:12:14 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-03-08 19:13:17 +01:00
2022-04-28 00:27:48 +02:00
msg_info "Checking Internet Status"
INTER=$(wget -q --tries=10 --timeout=5 --spider https://google.com)
sleep 2
if [[ $INTER -eq 0 ]]; then
2022-04-23 19:38:33 +02:00
msg_ok "Internet Online"
else
2022-04-28 00:27:48 +02:00
echo -e "${CROSS}${RD} Internet Offline"
2022-04-23 19:38:33 +02:00
fi
2022-04-17 22:12:14 +02:00
msg_info "Updating Container OS"
apt update &>/dev/null
2022-03-08 19:13:17 +01:00
apt-get -qqy upgrade &>/dev/null
2022-04-17 22:12:14 +02:00
msg_ok "Updated Container OS"
2022-03-08 19:13:17 +01:00
2022-04-17 22:12:14 +02:00
msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-04-17 22:31:51 +02:00
apt-get install -y git &>/dev/null
2022-04-17 22:12:14 +02:00
msg_ok "Installed Dependencies"
2022-03-08 19:13:17 +01:00
2022-04-17 22:12:14 +02:00
msg_info "Installing pip3"
apt-get install -y python3-pip &>/dev/null
msg_ok "Installed pip3"
2022-03-08 19:13:17 +01:00
2022-04-17 22:12:14 +02:00
msg_info "Installing ESPHome"
2022-03-08 19:13:17 +01:00
pip3 install esphome &>/dev/null
2022-04-17 22:12:14 +02:00
msg_ok "Installed ESPHome"
2022-03-08 19:13:17 +01:00
2022-04-17 22:12:14 +02:00
msg_info "Installing ESPHome Dashboard"
2022-03-08 19:13:17 +01:00
pip3 install tornado esptool &>/dev/null
service_path="/etc/systemd/system/esphomeDashboard.service"
echo "[Unit]
Description=ESPHome Dashboard
After=network.target
[Service]
ExecStart=/usr/local/bin/esphome /root/config/ dashboard
Restart=always
User=root
[Install]
WantedBy=multi-user.target" > $service_path
systemctl enable esphomeDashboard.service &>/dev/null
systemctl start esphomeDashboard
2022-04-17 22:12:14 +02:00
msg_ok "Installed ESPHome Dashboard"
2022-03-08 19:13:17 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
2022-04-17 22:12:14 +02:00
msg_info "Customizing Container"
2022-03-08 19:13:17 +01:00
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat << EOF > $GETTY_OVERRIDE
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
2022-04-17 22:12:14 +02:00
msg_ok "Customized Container"
2022-03-08 19:13:17 +01:00
fi
2022-04-17 22:12:14 +02:00
msg_info "Cleaning up"
2022-03-08 19:13:17 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
2022-04-17 22:12:14 +02:00
msg_ok "Cleaned"